Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Olympus.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Olympus.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Olympus.pm	(revision 34921)
@@ -10,6 +10,6 @@
 #               2) http://www.cybercom.net/~dcoffin/dcraw/
 #               3) http://www.ozhiker.com/electronics/pjmt/jpeg_info/olympus_mn.html
-#               4) Markku Hnninen private communication (tests with E-1)
-#               5) Rmi Guyomarch from http://forums.dpreview.com/forums/read.asp?forum=1022&message=12790396
+#               4) Markku Hanninen private communication (tests with E-1)
+#               5) Remi Guyomarch from http://forums.dpreview.com/forums/read.asp?forum=1022&message=12790396
 #               6) Frank Ledwon private communication (tests with E/C-series cameras)
 #               7) Michael Meissner private communication
@@ -17,12 +17,18 @@
 #               9) Mark Dapoz private communication
 #              10) Lilo Huang private communication (E-330)
-#              11) http://olypedia.de/Olympus_Makernotes
+#              11) http://olypedia.de/Olympus_Makernotes (May 30, 2013)
 #              12) Ioannis Panagiotopoulos private communication (E-510)
 #              13) Chris Shaw private communication (E-3)
 #              14) Viktor Lushnikov private communication (E-400)
 #              15) Yrjo Rauste private communication (E-30)
-#              16) Godfrey DiGiorgi private communcation (E-P1) + http://forums.dpreview.com/forums/read.asp?message=33187567
+#              16) Godfrey DiGiorgi private communication (E-P1) + http://forums.dpreview.com/forums/read.asp?message=33187567
 #              17) Martin Hibers private communication
 #              18) Tomasz Kawecki private communication
+#              19) Brad Grier private communication
+#              22) Herbert Kauer private communication
+#              23) Daniel Pollock private communication (PEN-F)
+#              24) Sebastian private communication (E-M1 Mark III)
+#              IB) Iliah Borg private communication (LibRaw)
+#              NJ) Niels Kristian Bech Jensen private communication
 #------------------------------------------------------------------------------
 
@@ -31,8 +37,9 @@
 use strict;
 use vars qw($VERSION);
+use Image::ExifTool qw(:DataAccess :Utils);
 use Image::ExifTool::Exif;
 use Image::ExifTool::APP12;
 
-$VERSION = '1.79';
+$VERSION = '2.70';
 
 sub PrintLensInfo($$$);
@@ -41,83 +48,527 @@
 
 # lookup for Olympus LensType values
+# (as of ExifTool 9.15, this was the complete list of chipped lenses at www.four-thirds.org)
 my %olympusLensTypes = (
-    '0 0 0'  => 'None',
-    # Olympus lenses
-    '0 1 0'  => 'Olympus Zuiko Digital ED 50mm F2.0 Macro',
-    '0 1 1'  => 'Olympus Zuiko Digital 40-150mm F3.5-4.5', #8
-    '0 1 16' => 'Olympus M.Zuiko Digital ED 14-42mm F3.5-5.6', #PH (E-P1 pre-production)
-    '0 2 0'  => 'Olympus Zuiko Digital ED 150mm F2.0',
-    '0 2 16' => 'Olympus M.Zuiko Digital 17mm F2.8 Pancake', #PH (E-P1 pre-production)
-    '0 3 0'  => 'Olympus Zuiko Digital ED 300mm F2.8',
-    '0 3 16' => 'Olympus M.Zuiko Digital ED 14-150mm F4.0-5.6', #11
-    '0 4 16' => 'Olympus M.Zuiko Digital ED 9-18mm F4.0-5.6', #11
-    '0 5 0'  => 'Olympus Zuiko Digital 14-54mm F2.8-3.5',
-    '0 5 1'  => 'Olympus Zuiko Digital Pro ED 90-250mm F2.8', #9
-    '0 5 16' => 'Olympus M.Zuiko Digital ED 14-42mm F3.5-5.6', #11
-    '0 6 0'  => 'Olympus Zuiko Digital ED 50-200mm F2.8-3.5',
-    '0 6 1'  => 'Olympus Zuiko Digital ED 8mm F3.5 Fisheye', #9
-    '0 7 0'  => 'Olympus Zuiko Digital 11-22mm F2.8-3.5',
-    '0 7 1'  => 'Olympus Zuiko Digital 18-180mm F3.5-6.3', #6
-    '0 8 1'  => 'Olympus Zuiko Digital 70-300mm F4.0-5.6', #7 (seen as release 1 - PH)
-    '0 9 16' => 'Olympus M.Zuiko Digital 14-42mm F3.5-5.6 II', #PH (E-PL2)
-    '0 21 0' => 'Olympus Zuiko Digital ED 7-14mm F4.0',
-    '0 23 0' => 'Olympus Zuiko Digital Pro ED 35-100mm F2.0', #7
-    '0 24 0' => 'Olympus Zuiko Digital 14-45mm F3.5-5.6',
-    '0 32 0' => 'Olympus Zuiko Digital 35mm F3.5 Macro', #9
-    '0 34 0' => 'Olympus Zuiko Digital 17.5-45mm F3.5-5.6', #9
-    '0 35 0' => 'Olympus Zuiko Digital ED 14-42mm F3.5-5.6', #PH
-    '0 36 0' => 'Olympus Zuiko Digital ED 40-150mm F4.0-5.6', #PH
-    '0 48 0' => 'Olympus Zuiko Digital ED 50-200mm F2.8-3.5 SWD', #7
-    '0 49 0' => 'Olympus Zuiko Digital ED 12-60mm F2.8-4.0 SWD', #7
-    '0 50 0' => 'Olympus Zuiko Digital ED 14-35mm F2.0 SWD', #PH
-    '0 51 0' => 'Olympus Zuiko Digital 25mm F2.8', #PH
-    '0 52 0' => 'Olympus Zuiko Digital ED 9-18mm F4.0-5.6', #7
-    '0 53 0' => 'Olympus Zuiko Digital 14-54mm F2.8-3.5 II', #PH
+    Notes => q{
+        The numerical values below are given in hexadecimal.  (Prior to ExifTool
+        9.15 these were in decimal.)
+    },
+    '0 00 00' => 'None',
+    # Olympus lenses (also Kenko Tokina)
+    '0 01 00' => 'Olympus Zuiko Digital ED 50mm F2.0 Macro',
+    '0 01 01' => 'Olympus Zuiko Digital 40-150mm F3.5-4.5', #8
+    '0 01 10' => 'Olympus M.Zuiko Digital ED 14-42mm F3.5-5.6', #PH (E-P1 pre-production)
+    '0 02 00' => 'Olympus Zuiko Digital ED 150mm F2.0',
+    '0 02 10' => 'Olympus M.Zuiko Digital 17mm F2.8 Pancake', #PH (E-P1 pre-production)
+    '0 03 00' => 'Olympus Zuiko Digital ED 300mm F2.8',
+    '0 03 10' => 'Olympus M.Zuiko Digital ED 14-150mm F4.0-5.6 [II]', #11 (The second version of this lens seems to have the same lens ID number as the first version #NJ)
+    '0 04 10' => 'Olympus M.Zuiko Digital ED 9-18mm F4.0-5.6', #11
+    '0 05 00' => 'Olympus Zuiko Digital 14-54mm F2.8-3.5',
+    '0 05 01' => 'Olympus Zuiko Digital Pro ED 90-250mm F2.8', #9
+    '0 05 10' => 'Olympus M.Zuiko Digital ED 14-42mm F3.5-5.6 L', #11 (E-PL1)
+    '0 06 00' => 'Olympus Zuiko Digital ED 50-200mm F2.8-3.5',
+    '0 06 01' => 'Olympus Zuiko Digital ED 8mm F3.5 Fisheye', #9
+    '0 06 10' => 'Olympus M.Zuiko Digital ED 40-150mm F4.0-5.6', #PH
+    '0 07 00' => 'Olympus Zuiko Digital 11-22mm F2.8-3.5',
+    '0 07 01' => 'Olympus Zuiko Digital 18-180mm F3.5-6.3', #6
+    '0 07 10' => 'Olympus M.Zuiko Digital ED 12mm F2.0', #PH
+    '0 08 01' => 'Olympus Zuiko Digital 70-300mm F4.0-5.6', #7 (seen as release 1 - PH)
+    '0 08 10' => 'Olympus M.Zuiko Digital ED 75-300mm F4.8-6.7', #PH
+    '0 09 10' => 'Olympus M.Zuiko Digital 14-42mm F3.5-5.6 II', #PH (E-PL2)
+    '0 10 01' => 'Kenko Tokina Reflex 300mm F6.3 MF Macro', #NJ
+    '0 10 10' => 'Olympus M.Zuiko Digital ED 12-50mm F3.5-6.3 EZ', #PH
+    '0 11 10' => 'Olympus M.Zuiko Digital 45mm F1.8', #17
+    '0 12 10' => 'Olympus M.Zuiko Digital ED 60mm F2.8 Macro', #NJ
+    '0 13 10' => 'Olympus M.Zuiko Digital 14-42mm F3.5-5.6 II R', #PH/NJ
+    '0 14 10' => 'Olympus M.Zuiko Digital ED 40-150mm F4.0-5.6 R', #19
+  # '0 14 10.1' => 'Olympus M.Zuiko Digital ED 14-150mm F4.0-5.6 II', #11 (questionable & unconfirmed -- all samples I can find are '0 3 10' - PH)
+    '0 15 00' => 'Olympus Zuiko Digital ED 7-14mm F4.0',
+    '0 15 10' => 'Olympus M.Zuiko Digital ED 75mm F1.8', #PH
+    '0 16 10' => 'Olympus M.Zuiko Digital 17mm F1.8', #NJ
+    '0 17 00' => 'Olympus Zuiko Digital Pro ED 35-100mm F2.0', #7
+    '0 18 00' => 'Olympus Zuiko Digital 14-45mm F3.5-5.6',
+    '0 18 10' => 'Olympus M.Zuiko Digital ED 75-300mm F4.8-6.7 II', #NJ
+    '0 19 10' => 'Olympus M.Zuiko Digital ED 12-40mm F2.8 Pro', #PH
+    '0 20 00' => 'Olympus Zuiko Digital 35mm F3.5 Macro', #9
+    '0 20 10' => 'Olympus M.Zuiko Digital ED 40-150mm F2.8 Pro', #NJ
+    '0 21 10' => 'Olympus M.Zuiko Digital ED 14-42mm F3.5-5.6 EZ', #NJ
+    '0 22 00' => 'Olympus Zuiko Digital 17.5-45mm F3.5-5.6', #9
+    '0 22 10' => 'Olympus M.Zuiko Digital 25mm F1.8', #NJ
+    '0 23 00' => 'Olympus Zuiko Digital ED 14-42mm F3.5-5.6', #PH
+    '0 23 10' => 'Olympus M.Zuiko Digital ED 7-14mm F2.8 Pro', #NJ
+    '0 24 00' => 'Olympus Zuiko Digital ED 40-150mm F4.0-5.6', #PH
+    '0 24 10' => 'Olympus M.Zuiko Digital ED 300mm F4.0 IS Pro', #NJ
+    '0 25 10' => 'Olympus M.Zuiko Digital ED 8mm F1.8 Fisheye Pro', #NJ
+    '0 26 10' => 'Olympus M.Zuiko Digital ED 12-100mm F4.0 IS Pro', #IB/NJ
+    '0 27 10' => 'Olympus M.Zuiko Digital ED 30mm F3.5 Macro', #IB/NJ
+    '0 28 10' => 'Olympus M.Zuiko Digital ED 25mm F1.2 Pro', #IB/NJ
+    '0 29 10' => 'Olympus M.Zuiko Digital ED 17mm F1.2 Pro', #IB
+    '0 30 00' => 'Olympus Zuiko Digital ED 50-200mm F2.8-3.5 SWD', #7
+    '0 30 10' => 'Olympus M.Zuiko Digital ED 45mm F1.2 Pro', #IB
+    '0 31 00' => 'Olympus Zuiko Digital ED 12-60mm F2.8-4.0 SWD', #7
+    '0 32 00' => 'Olympus Zuiko Digital ED 14-35mm F2.0 SWD', #PH
+    '0 32 10' => 'Olympus M.Zuiko Digital ED 12-200mm F3.5-6.3', #IB
+    '0 33 00' => 'Olympus Zuiko Digital 25mm F2.8', #PH
+    '0 33 10' => 'Olympus M.Zuiko Digital 150-400mm F4.5 TC1.25x IS Pro', #IB
+    '0 34 00' => 'Olympus Zuiko Digital ED 9-18mm F4.0-5.6', #7
+    '0 34 10' => 'Olympus M.Zuiko Digital ED 12-45mm F4.0 Pro', #IB
+    '0 35 00' => 'Olympus Zuiko Digital 14-54mm F2.8-3.5 II', #PH
     # Sigma lenses
-    '1 1 0'  => 'Sigma 18-50mm F3.5-5.6', #8
-    '1 2 0'  => 'Sigma 55-200mm F4.0-5.6 DC',
-    '1 3 0'  => 'Sigma 18-125mm F3.5-5.6 DC',
-    '1 4 0'  => 'Sigma 18-125mm F3.5-5.6', #7
-    '1 5 0'  => 'Sigma 30mm F1.4', #10
-    '1 6 0'  => 'Sigma 50-500mm F4.0-6.3 EX DG APO HSM RF', #6
-    '1 7 0'  => 'Sigma 105mm F2.8 DG', #PH
-    '1 8 0'  => 'Sigma 150mm F2.8 DG HSM', #PH
-    '1 16 0' => 'Sigma 24mm F1.8 EX DG Aspherical Macro', #PH
-    '1 17 0' => 'Sigma 135-400mm F4.5-5.6 DG ASP APO RF', #11
-    '1 18 0' => 'Sigma 300-800mm F5.6 EX DG APO', #11
-    '1 20 0' => 'Sigma 50-500mm F4.0-6.3 EX DG APO HSM RF', #11
-    '1 21 0' => 'Sigma 10-20mm F4.0-5.6 EX DC HSM', #11
-    '1 22 0' => 'Sigma 70-200mm F2.8 EX DG Macro HSM II', #11
-    '1 23 0' => 'Sigma 50mm F1.4 EX DG HSM', #11
-    # Leica lenses (ref 11)
-    '2 1 0'  => 'Leica D Vario Elmarit 14-50mm F2.8-3.5 Asph.',
-    '2 1 16' => 'Lumix G Vario 14-45mm F3.5-5.6 Asph. Mega OIS', #16
-    '2 2 0'  => 'Leica D Summilux 25mm F1.4 Asph.',
-    '2 2 16' => 'Lumix G Vario 45-200mm F4-5.6 Mega OIS', #16
-    '2 3 1'  => 'Leica D Vario Elmar 14-50mm F3.8-5.6 Asph.', #14 (L10 kit)
-    '2 3 16' => 'Lumix G Vario HD 14-140mm F4-5.8 Asph. Mega OIS', #16
-    '2 4 0'  => 'Leica D Vario Elmar 14-150mm F3.5-5.6', #13
-    '2 4 16' => 'Lumix G Vario 7-14mm F4 Asph.', #PH (E-P1 pre-production)
-    '2 5 16' => 'Lumix G 20mm F1.7 Asph.', #16
-    '2 6 16' => 'Leica DG Macro-Elmarit 45mm F2.8', #PH
-    '2 8 16' => 'Lumix G Fisheye 8mm F3.5', #PH
-    '3 1 0'  => 'Leica D Vario Elmarit 14-50mm F2.8-3.5 Asph.',
-    '3 2 0'  => 'Leica D Summilux 25mm F1.4 Asph.',
+    '1 01 00' => 'Sigma 18-50mm F3.5-5.6 DC', #8
+    '1 01 10' => 'Sigma 30mm F2.8 EX DN', #NJ
+    '1 02 00' => 'Sigma 55-200mm F4.0-5.6 DC',
+    '1 02 10' => 'Sigma 19mm F2.8 EX DN', #NJ
+    '1 03 00' => 'Sigma 18-125mm F3.5-5.6 DC',
+    '1 03 10' => 'Sigma 30mm F2.8 DN | A', #NJ
+    '1 04 00' => 'Sigma 18-125mm F3.5-5.6 DC', #7
+    '1 04 10' => 'Sigma 19mm F2.8 DN | A', #NJ
+    '1 05 00' => 'Sigma 30mm F1.4 EX DC HSM', #10
+    '1 05 10' => 'Sigma 60mm F2.8 DN | A', #NJ
+    '1 06 00' => 'Sigma APO 50-500mm F4.0-6.3 EX DG HSM', #6
+    '1 06 10' => 'Sigma 30mm F1.4 DC DN | C', #NJ
+    '1 07 00' => 'Sigma Macro 105mm F2.8 EX DG', #PH
+    '1 07 10' => 'Sigma 16mm F1.4 DC DN | C (017)', #IB
+    '1 08 00' => 'Sigma APO Macro 150mm F2.8 EX DG HSM', #PH
+    '1 09 00' => 'Sigma 18-50mm F2.8 EX DC Macro', #NJ
+    '1 10 00' => 'Sigma 24mm F1.8 EX DG Aspherical Macro', #PH
+    '1 11 00' => 'Sigma APO 135-400mm F4.5-5.6 DG', #11
+    '1 12 00' => 'Sigma APO 300-800mm F5.6 EX DG HSM', #11
+    '1 13 00' => 'Sigma 30mm F1.4 EX DC HSM', #11
+    '1 14 00' => 'Sigma APO 50-500mm F4.0-6.3 EX DG HSM', #11
+    '1 15 00' => 'Sigma 10-20mm F4.0-5.6 EX DC HSM', #11
+    '1 16 00' => 'Sigma APO 70-200mm F2.8 II EX DG Macro HSM', #11
+    '1 17 00' => 'Sigma 50mm F1.4 EX DG HSM', #11
+    '1 18 60' => 'Test',
+    # Panasonic/Leica lenses
+    '2 01 00' => 'Leica D Vario Elmarit 14-50mm F2.8-3.5 Asph.', #11
+    '2 01 10' => 'Lumix G Vario 14-45mm F3.5-5.6 Asph. Mega OIS', #16
+    '2 02 00' => 'Leica D Summilux 25mm F1.4 Asph.', #11
+    '2 02 10' => 'Lumix G Vario 45-200mm F4.0-5.6 Mega OIS', #16
+    '2 03 00' => 'Leica D Vario Elmar 14-50mm F3.8-5.6 Asph. Mega OIS', #11
+    '2 03 01' => 'Leica D Vario Elmar 14-50mm F3.8-5.6 Asph.', #14 (L10 kit)
+    '2 03 10' => 'Lumix G Vario HD 14-140mm F4.0-5.8 Asph. Mega OIS', #16
+    '2 04 00' => 'Leica D Vario Elmar 14-150mm F3.5-5.6', #13
+    '2 04 10' => 'Lumix G Vario 7-14mm F4.0 Asph.', #PH (E-P1 pre-production)
+    '2 05 10' => 'Lumix G 20mm F1.7 Asph.', #16
+    '2 06 10' => 'Leica DG Macro-Elmarit 45mm F2.8 Asph. Mega OIS', #PH
+    '2 07 10' => 'Lumix G Vario 14-42mm F3.5-5.6 Asph. Mega OIS', #NJ
+    '2 08 10' => 'Lumix G Fisheye 8mm F3.5', #PH
+    '2 09 10' => 'Lumix G Vario 100-300mm F4.0-5.6 Mega OIS', #11
+    '2 10 10' => 'Lumix G 14mm F2.5 Asph.', #17
+    '2 11 10' => 'Lumix G 12.5mm F12 3D', #NJ (H-FT012)
+    '2 12 10' => 'Leica DG Summilux 25mm F1.4 Asph.', #NJ
+    '2 13 10' => 'Lumix G X Vario PZ 45-175mm F4.0-5.6 Asph. Power OIS', #NJ
+    '2 14 10' => 'Lumix G X Vario PZ 14-42mm F3.5-5.6 Asph. Power OIS', #NJ
+    '2 15 10' => 'Lumix G X Vario 12-35mm F2.8 Asph. Power OIS', #PH
+    '2 16 10' => 'Lumix G Vario 45-150mm F4.0-5.6 Asph. Mega OIS', #NJ
+    '2 17 10' => 'Lumix G X Vario 35-100mm F2.8 Power OIS', #PH
+    '2 18 10' => 'Lumix G Vario 14-42mm F3.5-5.6 II Asph. Mega OIS', #NJ
+    '2 19 10' => 'Lumix G Vario 14-140mm F3.5-5.6 Asph. Power OIS', #NJ
+    '2 20 10' => 'Lumix G Vario 12-32mm F3.5-5.6 Asph. Mega OIS', #NJ
+    '2 21 10' => 'Leica DG Nocticron 42.5mm F1.2 Asph. Power OIS', #NJ
+    '2 22 10' => 'Leica DG Summilux 15mm F1.7 Asph.', #NJ
+    '2 23 10' => 'Lumix G Vario 35-100mm F4.0-5.6 Asph. Mega OIS', #NJ
+    '2 24 10' => 'Lumix G Macro 30mm F2.8 Asph. Mega OIS', #NJ
+    '2 25 10' => 'Lumix G 42.5mm F1.7 Asph. Power OIS', #NJ
+    '2 26 10' => 'Lumix G 25mm F1.7 Asph.', #NJ
+    '2 27 10' => 'Leica DG Vario-Elmar 100-400mm F4.0-6.3 Asph. Power OIS', #NJ
+    '2 28 10' => 'Lumix G Vario 12-60mm F3.5-5.6 Asph. Power OIS', #NJ
+    '2 29 10' => 'Leica DG Summilux 12mm F1.4 Asph.', #IB
+    '2 30 10' => 'Leica DG Vario-Elmarit 12-60mm F2.8-4 Asph. Power OIS', #IB
+    '2 31 10' => 'Lumix G Vario 45-200mm F4.0-5.6 II', #forum3833
+    '2 32 10' => 'Lumix G Vario 100-300mm F4.0-5.6 II', #PH
+    '2 33 10' => 'Lumix G X Vario 12-35mm F2.8 II Asph. Power OIS', #IB
+    '2 34 10' => 'Lumix G Vario 35-100mm F2.8 II', #forum3833
+    '2 35 10' => 'Leica DG Vario-Elmarit 8-18mm F2.8-4 Asph.', #IB
+    '2 36 10' => 'Leica DG Elmarit 200mm F2.8 Power OIS', #IB
+    '2 37 10' => 'Leica DG Vario-Elmarit 50-200mm F2.8-4 Asph. Power OIS', #IB
+    '2 38 10' => 'Leica DG Vario-Summilux 10-25mm F1.7 Asph.', #IB
+    '3 01 00' => 'Leica D Vario Elmarit 14-50mm F2.8-3.5 Asph.', #11
+    '3 02 00' => 'Leica D Summilux 25mm F1.4 Asph.', #11
+    # Tamron lenses
+    '5 01 10' => 'Tamron 14-150mm F3.5-5.8 Di III', #NJ (model C001)
+  # '65535 07 40' - Seen for LUMIX S 16-35/F4 on Panasonic DC-S1H (ref PH)
+    # Other makes
+    '24 01 10' => 'Venus Optics Laowa 50mm F2.8 2x Macro', #DonKomarechka
 );
 
-# ArtFilter and MagicFilter values (ref PH)
+# lookup for Olympus camera types (ref PH)
+my %olympusCameraTypes = (
+    Notes => q{
+        These values are currently decoded only for Olympus models.  Models with
+        Olympus-style maker notes from other brands such as Acer, BenQ, Hitachi, HP,
+        Premier, Konica-Minolta, Maginon, Ricoh, Rollei, SeaLife, Sony, Supra,
+        Vivitar are not listed.
+    },
+    D4028 => 'X-2,C-50Z',
+    D4029 => 'E-20,E-20N,E-20P',
+    D4034 => 'C720UZ',
+    D4040 => 'E-1',
+    D4041 => 'E-300',
+    D4083 => 'C2Z,D520Z,C220Z',
+    D4106 => 'u20D,S400D,u400D',
+    D4120 => 'X-1',
+    D4122 => 'u10D,S300D,u300D',
+    D4125 => 'AZ-1',
+    D4141 => 'C150,D390',
+    D4193 => 'C-5000Z',
+    D4194 => 'X-3,C-60Z',
+    D4199 => 'u30D,S410D,u410D',
+    D4205 => 'X450,D535Z,C370Z',
+    D4210 => 'C160,D395',
+    D4211 => 'C725UZ',
+    D4213 => 'FerrariMODEL2003',
+    D4216 => 'u15D',
+    D4217 => 'u25D',
+    D4220 => 'u-miniD,Stylus V',
+    D4221 => 'u40D,S500,uD500',
+    D4231 => 'FerrariMODEL2004',
+    D4240 => 'X500,D590Z,C470Z',
+    D4244 => 'uD800,S800',
+    D4256 => 'u720SW,S720SW',
+    D4261 => 'X600,D630,FE5500',
+    D4262 => 'uD600,S600',
+    D4301 => 'u810/S810', # (yes, "/".  Olympus is not consistent in the notation)
+    D4302 => 'u710,S710',
+    D4303 => 'u700,S700',
+    D4304 => 'FE100,X710',
+    D4305 => 'FE110,X705',
+    D4310 => 'FE-130,X-720',
+    D4311 => 'FE-140,X-725',
+    D4312 => 'FE150,X730',
+    D4313 => 'FE160,X735',
+    D4314 => 'u740,S740',
+    D4315 => 'u750,S750',
+    D4316 => 'u730/S730',
+    D4317 => 'FE115,X715',
+    D4321 => 'SP550UZ',
+    D4322 => 'SP510UZ',
+    D4324 => 'FE170,X760',
+    D4326 => 'FE200',
+    D4327 => 'FE190/X750', # (also SX876)
+    D4328 => 'u760,S760',
+    D4330 => 'FE180/X745', # (also SX875)
+    D4331 => 'u1000/S1000',
+    D4332 => 'u770SW,S770SW',
+    D4333 => 'FE240/X795',
+    D4334 => 'FE210,X775',
+    D4336 => 'FE230/X790',
+    D4337 => 'FE220,X785',
+    D4338 => 'u725SW,S725SW',
+    D4339 => 'FE250/X800',
+    D4341 => 'u780,S780',
+    D4343 => 'u790SW,S790SW',
+    D4344 => 'u1020,S1020',
+    D4346 => 'FE15,X10',
+    D4348 => 'FE280,X820,C520',
+    D4349 => 'FE300,X830',
+    D4350 => 'u820,S820',
+    D4351 => 'u1200,S1200',
+    D4352 => 'FE270,X815,C510',
+    D4353 => 'u795SW,S795SW',
+    D4354 => 'u1030SW,S1030SW',
+    D4355 => 'SP560UZ',
+    D4356 => 'u1010,S1010',
+    D4357 => 'u830,S830',
+    D4359 => 'u840,S840',
+    D4360 => 'FE350WIDE,X865',
+    D4361 => 'u850SW,S850SW',
+    D4362 => 'FE340,X855,C560',
+    D4363 => 'FE320,X835,C540',
+    D4364 => 'SP570UZ',
+    D4366 => 'FE330,X845,C550',
+    D4368 => 'FE310,X840,C530',
+    D4370 => 'u1050SW,S1050SW',
+    D4371 => 'u1060,S1060',
+    D4372 => 'FE370,X880,C575',
+    D4374 => 'SP565UZ',
+    D4377 => 'u1040,S1040',
+    D4378 => 'FE360,X875,C570',
+    D4379 => 'FE20,X15,C25',
+    D4380 => 'uT6000,ST6000',
+    D4381 => 'uT8000,ST8000',
+    D4382 => 'u9000,S9000',
+    D4384 => 'SP590UZ',
+    D4385 => 'FE3010,X895',
+    D4386 => 'FE3000,X890',
+    D4387 => 'FE35,X30',
+    D4388 => 'u550WP,S550WP',
+    D4390 => 'FE5000,X905',
+    D4391 => 'u5000',
+    D4392 => 'u7000,S7000',
+    D4396 => 'FE5010,X915',
+    D4397 => 'FE25,X20',
+    D4398 => 'FE45,X40',
+    D4401 => 'XZ-1',
+    D4402 => 'uT6010,ST6010',
+    D4406 => 'u7010,S7010 / u7020,S7020',
+    D4407 => 'FE4010,X930',
+    D4408 => 'X560WP',
+    D4409 => 'FE26,X21',
+    D4410 => 'FE4000,X920,X925',
+    D4411 => 'FE46,X41,X42',
+    D4412 => 'FE5020,X935',
+    D4413 => 'uTough-3000',
+    D4414 => 'StylusTough-6020',
+    D4415 => 'StylusTough-8010',
+    D4417 => 'u5010,S5010',
+    D4418 => 'u7040,S7040',
+    D4419 => 'u9010,S9010',
+    D4423 => 'FE4040',
+    D4424 => 'FE47,X43',
+    D4426 => 'FE4030,X950',
+    D4428 => 'FE5030,X965,X960',
+    D4430 => 'u7030,S7030',
+    D4432 => 'SP600UZ',
+    D4434 => 'SP800UZ',
+    D4439 => 'FE4020,X940',
+    D4442 => 'FE5035',
+    D4448 => 'FE4050,X970',
+    D4450 => 'FE5050,X985',
+    D4454 => 'u-7050',
+    D4464 => 'T10,X27',
+    D4470 => 'FE5040,X980',
+    D4472 => 'TG-310',
+    D4474 => 'TG-610',
+    D4476 => 'TG-810',
+    D4478 => 'VG145,VG140,D715',
+    D4479 => 'VG130,D710',
+    D4480 => 'VG120,D705',
+    D4482 => 'VR310,D720',
+    D4484 => 'VR320,D725',
+    D4486 => 'VR330,D730',
+    D4488 => 'VG110,D700',
+    D4490 => 'SP-610UZ',
+    D4492 => 'SZ-10',
+    D4494 => 'SZ-20',
+    D4496 => 'SZ-30MR',
+    D4498 => 'SP-810UZ',
+    D4500 => 'SZ-11',
+    D4504 => 'TG-615',
+    D4508 => 'TG-620',
+    D4510 => 'TG-820',
+    D4512 => 'TG-1',
+    D4516 => 'SH-21',
+    D4519 => 'SZ-14',
+    D4520 => 'SZ-31MR',
+    D4521 => 'SH-25MR',
+    D4523 => 'SP-720UZ',
+    D4529 => 'VG170',
+    D4531 => 'XZ-2',
+    D4535 => 'SP-620UZ',
+    D4536 => 'TG-320',
+    D4537 => 'VR340,D750',
+    D4538 => 'VG160,X990,D745',
+    D4541 => 'SZ-12',
+    D4545 => 'VH410',
+    D4546 => 'XZ-10', #IB
+    D4547 => 'TG-2',
+    D4548 => 'TG-830',
+    D4549 => 'TG-630',
+    D4550 => 'SH-50',
+    D4553 => 'SZ-16,DZ-105',
+    D4562 => 'SP-820UZ',
+    D4566 => 'SZ-15',
+    D4572 => 'STYLUS1',
+    D4574 => 'TG-3',
+    D4575 => 'TG-850',
+    D4579 => 'SP-100EE',
+    D4580 => 'SH-60',
+    D4581 => 'SH-1',
+    D4582 => 'TG-835',
+    D4585 => 'SH-2 / SH-3',
+    D4586 => 'TG-4',
+    D4587 => 'TG-860',
+    D4591 => 'TG-870',
+    D4593 => 'TG-5', #IB
+    D4603 => 'TG-6', #IB
+    D4809 => 'C2500L',
+    D4842 => 'E-10',
+    D4856 => 'C-1',
+    D4857 => 'C-1Z,D-150Z',
+    DCHC => 'D500L',
+    DCHT => 'D600L / D620L',
+    K0055 => 'AIR-A01',
+    S0003 => 'E-330',
+    S0004 => 'E-500',
+    S0009 => 'E-400',
+    S0010 => 'E-510',
+    S0011 => 'E-3',
+    S0013 => 'E-410',
+    S0016 => 'E-420',
+    S0017 => 'E-30',
+    S0018 => 'E-520',
+    S0019 => 'E-P1',
+    S0023 => 'E-620',
+    S0026 => 'E-P2',
+    S0027 => 'E-PL1',
+    S0029 => 'E-450',
+    S0030 => 'E-600',
+    S0032 => 'E-P3',
+    S0033 => 'E-5',
+    S0034 => 'E-PL2',
+    S0036 => 'E-M5',
+    S0038 => 'E-PL3',
+    S0039 => 'E-PM1',
+    S0040 => 'E-PL1s',
+    S0042 => 'E-PL5',
+    S0043 => 'E-PM2',
+    S0044 => 'E-P5',
+    S0045 => 'E-PL6',
+    S0046 => 'E-PL7', #IB
+    S0047 => 'E-M1',
+    S0051 => 'E-M10',
+    S0052 => 'E-M5MarkII', #IB
+    S0059 => 'E-M10MarkII',
+    S0061 => 'PEN-F', #forum7005
+    S0065 => 'E-PL8',
+    S0067 => 'E-M1MarkII',
+    S0068 => 'E-M10MarkIII',
+    S0076 => 'E-PL9', #IB
+    S0080 => 'E-M1X', #IB
+    S0085 => 'E-PL10', #IB
+    S0089 => 'E-M5MarkIII',
+    S0092 => 'E-M1MarkIII', #IB
+    SR45 => 'D220',
+    SR55 => 'D320L',
+    SR83 => 'D340L',
+    SR85 => 'C830L,D340R',
+    SR852 => 'C860L,D360L',
+    SR872 => 'C900Z,D400Z',
+    SR874 => 'C960Z,D460Z',
+    SR951 => 'C2000Z',
+    SR952 => 'C21',
+    SR953 => 'C21T.commu',
+    SR954 => 'C2020Z',
+    SR955 => 'C990Z,D490Z',
+    SR956 => 'C211Z',
+    SR959 => 'C990ZS,D490Z',
+    SR95A => 'C2100UZ',
+    SR971 => 'C100,D370',
+    SR973 => 'C2,D230',
+    SX151 => 'E100RS',
+    SX351 => 'C3000Z / C3030Z',
+    SX354 => 'C3040Z',
+    SX355 => 'C2040Z',
+    SX357 => 'C700UZ',
+    SX358 => 'C200Z,D510Z',
+    SX374 => 'C3100Z,C3020Z',
+    SX552 => 'C4040Z',
+    SX553 => 'C40Z,D40Z',
+    SX556 => 'C730UZ',
+    SX558 => 'C5050Z',
+    SX571 => 'C120,D380',
+    SX574 => 'C300Z,D550Z',
+    SX575 => 'C4100Z,C4000Z',
+    SX751 => 'X200,D560Z,C350Z',
+    SX752 => 'X300,D565Z,C450Z',
+    SX753 => 'C750UZ',
+    SX754 => 'C740UZ',
+    SX755 => 'C755UZ',
+    SX756 => 'C5060WZ',
+    SX757 => 'C8080WZ',
+    SX758 => 'X350,D575Z,C360Z',
+    SX759 => 'X400,D580Z,C460Z',
+    SX75A => 'AZ-2ZOOM',
+    SX75B => 'D595Z,C500Z',
+    SX75C => 'X550,D545Z,C480Z',
+    SX75D => 'IR-300',
+    SX75F => 'C55Z,C5500Z',
+    SX75G => 'C170,D425',
+    SX75J => 'C180,D435',
+    SX771 => 'C760UZ',
+    SX772 => 'C770UZ',
+    SX773 => 'C745UZ',
+    SX774 => 'X250,D560Z,C350Z',
+    SX775 => 'X100,D540Z,C310Z',
+    SX776 => 'C460ZdelSol',
+    SX777 => 'C765UZ',
+    SX77A => 'D555Z,C315Z',
+    SX851 => 'C7070WZ',
+    SX852 => 'C70Z,C7000Z',
+    SX853 => 'SP500UZ',
+    SX854 => 'SP310',
+    SX855 => 'SP350',
+    SX873 => 'SP320',
+    SX875 => 'FE180/X745', # (also D4330)
+    SX876 => 'FE190/X750', # (also D4327)
+#   other brands
+#    4MP9Q3 => 'Camera 4MP-9Q3'
+#    4MP9T2 => 'BenQ DC C420 / Camera 4MP-9T2'
+#    5MP9Q3 => 'Camera 5MP-9Q3',
+#    5MP9X9 => 'Camera 5MP-9X9',
+#   '5MP-9T'=> 'Camera 5MP-9T3',
+#   '5MP-9Y'=> 'Camera 5MP-9Y2',
+#   '6MP-9U'=> 'Camera 6MP-9U9',
+#    7MP9Q3 => 'Camera 7MP-9Q3',
+#   '8MP-9U'=> 'Camera 8MP-9U4',
+#    CE5330 => 'Acer CE-5330',
+#   'CP-853'=> 'Acer CP-8531',
+#    CS5531 => 'Acer CS5531',
+#    DC500  => 'SeaLife DC500',
+#    DC7370 => 'Camera 7MP-9GA',
+#    DC7371 => 'Camera 7MP-9GM',
+#    DC7371 => 'Hitachi HDC-751E',
+#    DC7375 => 'Hitachi HDC-763E / Rollei RCP-7330X / Ricoh Caplio RR770 / Vivitar ViviCam 7330',
+#   'DC E63'=> 'BenQ DC E63+',
+#   'DC P86'=> 'BenQ DC P860',
+#    DS5340 => 'Maginon Performic S5 / Premier 5MP-9M7',
+#    DS5341 => 'BenQ E53+ / Supra TCM X50 / Maginon X50 / Premier 5MP-9P8',
+#    DS5346 => 'Premier 5MP-9Q2',
+#    E500   => 'Konica Minolta DiMAGE E500',
+#    MAGINO => 'Maginon X60',
+#    Mz60   => 'HP Photosmart Mz60',
+#    Q3DIGI => 'Camera 5MP-9Q3',
+#    SLIMLI => 'Supra Slimline X6',
+#    V8300s => 'Vivitar V8300s',
+);
+
+# ArtFilter, ArtFilterEffect and MagicFilter values (ref PH)
 my %filters = (
-    '0'    => 'Off',
-    '1' => 'Soft Focus',
-    '2' => 'Pop Art',
-    '3' => 'Pale & Light Color',
-    '4' => 'Light Tone',
-    '5' => 'Pin Hole',
-    '6' => 'Grainy Film',
-    '9' => 'Diorama',
-    '10' => 'Cross Process',
-    '12' => 'Fish Eye',
-    '13' => 'Drawing',
-    # Punk? Sparkle?
+    0 => 'Off',
+    1 => 'Soft Focus', # (XZ-1)
+    2 => 'Pop Art', # (SZ-10 magic filter 1,SZ-31MR,E-M5,E-PL3)
+    3 => 'Pale & Light Color',
+    4 => 'Light Tone',
+    5 => 'Pin Hole', # (SZ-10 magic filter 2,SZ-31MR,E-PL3)
+    6 => 'Grainy Film',
+    9 => 'Diorama',
+    10 => 'Cross Process',
+    12 => 'Fish Eye', # (SZ-10 magic filter 3)
+    13 => 'Drawing', # (SZ-10 magic filter 4)
+    14 => 'Gentle Sepia', # (E-5)
+    15 => 'Pale & Light Color II', #forum6269 ('Tender Light' ref 11)
+    16 => 'Pop Art II', #11 (E-PL3 "(dark)" - PH)
+    17 => 'Pin Hole II', #11 (E-PL3 "(color 2)" - PH)
+    18 => 'Pin Hole III', #11 (E-M5, E-PL3 "(color 3)" - PH)
+    19 => 'Grainy Film II', #11
+    20 => 'Dramatic Tone', # (XZ-1,SZ-31MR)
+    21 => 'Punk', # (SZ-10 magic filter 6)
+    22 => 'Soft Focus 2', # (SZ-10 magic filter 5)
+    23 => 'Sparkle', # (SZ-10 magic filter 7)
+    24 => 'Watercolor', # (SZ-10 magic filter 8)
+    25 => 'Key Line', # (E-M5)
+    26 => 'Key Line II', #forum6269
+    27 => 'Miniature', # (SZ-31MR)
+    28 => 'Reflection', # (TG-820,SZ-31MR)
+    29 => 'Fragmented', # (TG-820,SZ-31MR)
+    31 => 'Cross Process II', #forum6269
+    32 => 'Dramatic Tone II',  #forum6269 (Dramatic Tone B&W for E-M5)
+    33 => 'Watercolor I', # ('Watercolor I' for EM-1 ref forum6269, 'Watercolor II' for E-PM2 ref PH)
+    34 => 'Watercolor II', #forum6269
+    35 => 'Diorama II', #forum6269
+    36 => 'Vintage', #forum6269
+    37 => 'Vintage II', #forum6269
+    38 => 'Vintage III', #forum6269
+    39 => 'Partial Color', #forum6269
+    40 => 'Partial Color II', #forum6269
+    41 => 'Partial Color III', #forum6269
+);
+
+my %toneLevelType = (
+    0 => '0',
+    -31999 => 'Highlights',
+    -31998 => 'Shadows',
+    -31997 => 'Midtones',
 );
 
@@ -184,12 +635,10 @@
     0x0100 => {
         Name => 'ThumbnailImage',
+        Groups => { 2 => 'Preview' },
         Writable => 'undef',
         WriteCheck => '$self->CheckImage(\$val)',
         Binary => 1,
     },
-    0x0104 => { #11
-        Name => 'BodyFirmwareVersion',
-        Writable => 'string',
-    },
+    0x0104 => { Name => 'BodyFirmwareVersion',    Writable => 'string' }, #11
 #
 # end Konica/Minolta tags
@@ -199,6 +648,6 @@
         Notes => q{
             3 numbers: 1. Shooting mode: 0=Normal, 2=Fast, 3=Panorama;
-            2. Sequence Number; 3. Panorama Direction: 1=Left-Right,
-            2=Right-Left, 3=Bottom-Top, 4=Top-Bottom
+            2. Sequence Number; 3. Panorama Direction: 1=Left-right,
+            2=Right-left, 3=Bottom-Top, 4=Top-Bottom
         },
         Writable => 'int32u',
@@ -236,5 +685,5 @@
                 6 => 'RAW', #PH - C5050WZ
             );
-            my %t2 = ( # all other types
+            my %t2 = ( # all other types (except D4322, ref 22)
                 1 => 'SQ (Low)',
                 2 => 'HQ (Normal)',
@@ -245,5 +694,5 @@
                 33 => 'Uncompressed', #PH - C2100Z
             );
-            my $conv = $self->{CameraType} =~ /^SX(?!151\b)/ ? \%t1 : \%t2;
+            my $conv = $self->{CameraType} =~ /^(SX(?!151\b)|D4322)/ ? \%t1 : \%t2;
             return $$conv{$val} ? $$conv{$val} : "Unknown ($val)";
         },
@@ -263,5 +712,9 @@
         Description => 'Black And White Mode',
         Writable => 'int16u',
-        PrintConv => \%offOn,
+        PrintConv => {
+            0 => 'Off',
+            1 => 'On',
+            6 => '(none)', #22
+        },
     },
     0x0204 => {
@@ -277,14 +730,17 @@
         PrintConvInv => '$val=~s/\s*mm$//;$val',
     },
-    0x0206 => { #6
-        Name => 'LensDistortionParams',
-        Writable => 'int16s',
-        Count => 6,
-    },
-    0x0207 => { #PH (was incorrectly FirmwareVersion, ref 1,3)
+    0x0206 => { Name => 'LensDistortionParams', Writable => 'int16s', Count => 6 }, #6
+    0x0207 => { #PH (was incorrectly FirmwareVersion, ref 1/3)
         Name => 'CameraType',
+        Condition => '$$valPt ne "NORMAL"', # FE240, SP510, u730 and u1000 write this
         Writable => 'string',
         DataMember => 'CameraType',
         RawConv => '$self->{CameraType} = $val',
+        SeparateTable => 'CameraType',
+        ValueConv => '$val =~ s/\s+$//; $val',  # ("SX151 " has trailing space)
+        ValueConvInv => '$val',
+        PrintConv => \%olympusCameraTypes,
+        Priority => 0,
+        # 'NORMAL' for some models: u730,SP510UZ,u1000,FE240
     },
     0x0208 => {
@@ -298,30 +754,16 @@
         Format => 'string', # this really should have been a string
     },
-    0x020b => { #PH
-        Name => 'EpsonImageWidth',
-        Writable => 'int16u',
-    },
-    0x020c => { #PH
-        Name => 'EpsonImageHeight',
-        Writable => 'int16u',
-    },
-    0x020d => { #PH
-        Name => 'EpsonSoftware',
-        Writable => 'string',
-    },
+    0x020b => { Name => 'EpsonImageWidth',  Writable => 'int32u' }, #PH
+    0x020c => { Name => 'EpsonImageHeight', Writable => 'int32u' }, #PH
+    0x020d => { Name => 'EpsonSoftware',    Writable => 'string' }, #PH
     0x0280 => { #PH
         %Image::ExifTool::previewImageTagInfo,
+        Groups => { 2 => 'Preview' },
         Notes => 'found in ERF and JPG images from some Epson models',
         Format => 'undef',
         Writable => 'int8u',
     },
-    0x0300 => { #6
-        Name => 'PreCaptureFrames',
-        Writable => 'int16u',
-    },
-    0x0301 => { #11
-        Name => 'WhiteBoard',
-        Writable => 'int16u',
-    },
+    0x0300 => { Name => 'PreCaptureFrames', Writable => 'int16u' }, #6
+    0x0301 => { Name => 'WhiteBoard',       Writable => 'int16u' }, #11
     0x0302 => { #6
         Name => 'OneTouchWB',
